"use strict";

var _require = require("lodash"),
    isFunction = _require.isFunction;

var defaultStrategy = require("./strategies/default");
var asyncStrategy = require("./strategies/async");

var cacheStrategy = defaultStrategy();

// eslint-disable-next-line max-params
var getFrameCache = function getFrameCache(node, cacheKey, delegateFn, Sequence) {
  return cacheStrategy(node, cacheKey, delegateFn, Sequence);
};

function setCacheStrategy(opts) {
  if (!isFunction(opts && opts.get) || !isFunction(opts && opts.set)) {
    throw new Error("Async cache strategy must be provided `get` and `set` options.");
  }
  cacheStrategy = asyncStrategy(opts);
}

function useDefaultCacheStrategy() {
  cacheStrategy = defaultStrategy();
}

module.exports = {
  getFrameCache,
  setCacheStrategy,
  useDefaultCacheStrategy
};